=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2008-10-24 03:07:51 +0000
+++ drizzled/drizzled.cc	2008-10-25 04:31:54 +0000
@@ -1389,7 +1389,7 @@
 }
 #endif
 
-#if BACKTRACE_DEMANGLE
+#if defined(BACKTRACE_DEMANGLE)
 #include <cxxabi.h>
 extern "C" char *my_demangle(const char *mangled_name, int *status)
 {

=== modified file 'drizzled/field/real.cc'
--- drizzled/field/real.cc	2008-10-23 03:41:40 +0000
+++ drizzled/field/real.cc	2008-10-25 04:31:54 +0000
@@ -19,6 +19,7 @@
  */
 
 
+using namespace std;
 #include <drizzled/server_includes.h>
 #include <drizzled/field/real.h>
 #include <drizzled/error.h>
@@ -73,7 +74,7 @@
   int error= 1;
   double res= *nr;
   
-  if (std::isnan(res))
+  if (isnan(res))
   {
     res= 0;
     set_null();
@@ -92,7 +93,7 @@
     max_value-= 1.0 / log_10[dec];
 
     /* Check for infinity so we don't get NaN in calculations */
-    if (!(std::isinf(res)))
+    if (!(isinf(res)))
     {
       double tmp= rint((res - floor(res)) * log_10[dec]) / log_10[dec];
       res= floor(res) + tmp;

=== modified file 'drizzled/functions/Makefile.am'
--- drizzled/functions/Makefile.am	2008-10-13 21:02:40 +0000
+++ drizzled/functions/Makefile.am	2008-10-24 03:43:19 +0000
@@ -17,22 +17,32 @@
 
 libfunctions_la_SOURCES = abs.cc \
 			  acos.cc \
+			  ascii.cc \
 			  asin.cc \
 			  atan.cc \
 			  additive_op.cc \
+			  benchmark.cc \
+			  bit.cc \
+			  bit_count.cc \
+			  char_length.cc \
 			  ceiling.cc \
 			  connection_id.cc \
+			  coercibility.cc \
 			  cos.cc \
 			  decimal_typecast.cc \
 			  divide.cc \
 			  exp.cc \
+			  find_in_set.cc \
 			  floor.cc \
 			  func.cc \
+			  get_system_var.cc \
                           int.cc \
                           int_divide.cc \
                           int_val.cc \
+			  last_insert.cc \
 			  length.cc \
 			  ln.cc \
+			  locate.cc \
 			  log.cc \
 			  min_max.cc \
 			  minus.cc \
@@ -42,6 +52,7 @@
 			  num1.cc \
                           numhybrid.cc \
                           num_op.cc \
+                          ord.cc \
                           plus.cc \
                           pow.cc \
 			  rand.cc \
@@ -52,27 +63,39 @@
 			  sin.cc \
 			  sqrt.cc \
 			  tan.cc \
+			  units.cc \
 			  unsigned.cc
 
 noinst_HEADERS = abs.h \
 		 acos.h \
+		 ascii.h \
 		 asin.h \
 		 atan.h \
 		 additive_op.h \
+		 benchmark.h \
+		 bit.h \
+		 bit_count.h \
+		 bit_length.h \
 		 ceiling.h \
+		 char_length.h \
+		 coercibility.h \
 		 connection_id.h \
 		 cos.h \
 		 dec.h \
 		 decimal_typecast.h \
 		 divide.h \
 		 exp.h \
+		 find_in_set.h \
 		 floor.h \
 		 func.h \
+		 get_system_var.h \
                  int.h \
                  int_divide.h \
                  int_val.h \
+		 last_insert.h \
 		 length.h \
 		 ln.h \
+		 locate.h \
 		 log.h \
 		 min_max.h \
 		 minus.h \
@@ -82,10 +105,11 @@
 		 num1.h \
                  numhybrid.h \
                  num_op.h \
+                 ord.h \
                  plus.h \
                  pow.h \
 		 real.h \
-		 round.h \
+		 rollup_const.h \
 		 round.h \
 		 sign.h \
 		 signed.h \

=== added file 'drizzled/functions/ascii.cc'
--- drizzled/functions/ascii.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/ascii.cc	2008-10-14 00:40:14 +0000
@@ -0,0 +1,36 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/ascii.h>
+
+int64_t Item_func_ascii::val_int()
+{
+  assert(fixed == 1);
+  String *res=args[0]->val_str(&value);
+  if (!res)
+  {
+    null_value=1;
+    return 0;
+  }
+  null_value=0;
+  return (int64_t) (res->length() ? (unsigned char) (*res)[0] : (unsigned char) 0);
+}
+

=== added file 'drizzled/functions/ascii.h'
--- drizzled/functions/ascii.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/ascii.h	2008-10-14 00:40:14 +0000
@@ -0,0 +1,35 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_ASCII_H
+#define DRIZZLED_FUNCTIONS_ASCII_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_ascii :public Item_int_func
+{
+  String value;
+public:
+  Item_func_ascii(Item *a) :Item_int_func(a) {}
+  int64_t val_int();
+  const char *func_name() const { return "ascii"; }
+  void fix_length_and_dec() { max_length=3; }
+};
+
+#endif /* DRIZZLED_FUNCTIONS_ASCII_H */

=== added file 'drizzled/functions/benchmark.cc'
--- drizzled/functions/benchmark.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/benchmark.cc	2008-10-25 04:31:54 +0000
@@ -0,0 +1,90 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/benchmark.h>
+#include <drizzled/error.h>
+
+
+/* This function is just used to test speed of different functions */
+
+int64_t Item_func_benchmark::val_int()
+{
+  assert(fixed == 1);
+  char buff[MAX_FIELD_WIDTH];
+  String tmp(buff,sizeof(buff), &my_charset_bin);
+  my_decimal tmp_decimal;
+  Session *session=current_session;
+  uint64_t loop_count;
+
+  loop_count= (uint64_t) args[0]->val_int();
+
+  if (args[0]->null_value ||
+      (!args[0]->unsigned_flag && (((int64_t) loop_count) < 0)))
+  {
+    if (!args[0]->null_value)
+    {
+      char buff[22];
+      llstr(((int64_t) loop_count), buff);
+      push_warning_printf(current_session, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
+                          ER_WRONG_VALUE_FOR_TYPE, ER(ER_WRONG_VALUE_FOR_TYPE),
+                          "count", buff, "benchmark");
+    }
+
+    null_value= 1;
+    return 0;
+  }
+
+  null_value=0;
+  for (uint64_t loop=0 ; loop < loop_count && !session->killed; loop++)
+  {
+    switch (args[1]->result_type()) {
+    case REAL_RESULT:
+      (void) args[1]->val_real();
+      break;
+    case INT_RESULT:
+      (void) args[1]->val_int();
+      break;
+    case STRING_RESULT:
+      (void) args[1]->val_str(&tmp);
+      break;
+    case DECIMAL_RESULT:
+      (void) args[1]->val_decimal(&tmp_decimal);
+      break;
+    case ROW_RESULT:
+    default:
+      // This case should never be chosen
+      assert(0);
+      return 0;
+    }
+  }
+  return 0;
+}
+
+
+void Item_func_benchmark::print(String *str, enum_query_type query_type)
+{
+  str->append(STRING_WITH_LEN("benchmark("));
+  args[0]->print(str, query_type);
+  str->append(',');
+  args[1]->print(str, query_type);
+  str->append(')');
+}
+

=== added file 'drizzled/functions/benchmark.h'
--- drizzled/functions/benchmark.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/benchmark.h	2008-10-24 03:43:19 +0000
@@ -0,0 +1,39 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_BENCHMARK_H
+#define DRIZZLED_FUNCTIONS_BENCHMARK_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_benchmark :public Item_int_func
+{
+public:
+  Item_func_benchmark(Item *count_expr, Item *expr)
+    :Item_int_func(count_expr, expr)
+  {}
+  int64_t val_int();
+  const char *func_name() const { return "benchmark"; }
+  void fix_length_and_dec() { max_length=1; maybe_null=0; }
+  virtual void print(String *str, enum_query_type query_type);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
+};
+
+#endif /* DRIZZLED_FUNCTIONS_BENCHMARK_H */

=== added file 'drizzled/functions/bit.cc'
--- drizzled/functions/bit.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/bit.cc	2008-10-17 03:49:29 +0000
@@ -0,0 +1,43 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/bit.h>
+
+int64_t Item_func_bit_neg::val_int()
+{
+  assert(fixed == 1);
+  uint64_t res= (uint64_t) args[0]->val_int();
+  if ((null_value=args[0]->null_value))
+    return 0;
+  return ~res;
+}
+
+int64_t Item_func_bit_xor::val_int()
+{
+  assert(fixed == 1);
+  uint64_t arg1= (uint64_t) args[0]->val_int();
+  uint64_t arg2= (uint64_t) args[1]->val_int();
+  if ((null_value= (args[0]->null_value || args[1]->null_value)))
+    return 0;
+  return (int64_t) (arg1 ^ arg2);
+}
+
+

=== added file 'drizzled/functions/bit.h'
--- drizzled/functions/bit.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/bit.h	2008-10-17 03:49:29 +0000
@@ -0,0 +1,92 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_BIT_H
+#define DRIZZLED_FUNCTIONS_BIT_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_bit: public Item_int_func
+{
+public:
+  Item_func_bit(Item *a, Item *b) :Item_int_func(a, b) {}
+  Item_func_bit(Item *a) :Item_int_func(a) {}
+  void fix_length_and_dec() { unsigned_flag= 1; }
+
+  virtual inline void print(String *str, enum_query_type query_type)
+  {
+    print_op(str, query_type);
+  }
+};
+
+class Item_func_bit_xor : public Item_func_bit
+{
+public:
+  Item_func_bit_xor(Item *a, Item *b) :Item_func_bit(a, b) {}
+  int64_t val_int();
+  const char *func_name() const { return "^"; }
+};
+
+class Item_func_bit_or :public Item_func_bit
+{
+public:
+  Item_func_bit_or(Item *a, Item *b) :Item_func_bit(a, b) {}
+  int64_t val_int();
+  const char *func_name() const { return "|"; }
+};
+
+class Item_func_bit_and :public Item_func_bit
+{
+public:
+  Item_func_bit_and(Item *a, Item *b) :Item_func_bit(a, b) {}
+  int64_t val_int();
+  const char *func_name() const { return "&"; }
+};
+
+class Item_func_shift_left :public Item_func_bit
+{
+public:
+  Item_func_shift_left(Item *a, Item *b) :Item_func_bit(a, b) {}
+  int64_t val_int();
+  const char *func_name() const { return "<<"; }
+};
+
+class Item_func_shift_right :public Item_func_bit
+{
+public:
+  Item_func_shift_right(Item *a, Item *b) :Item_func_bit(a, b) {}
+  int64_t val_int();
+  const char *func_name() const { return ">>"; }
+};
+
+class Item_func_bit_neg :public Item_func_bit
+{
+public:
+  Item_func_bit_neg(Item *a) :Item_func_bit(a) {}
+  int64_t val_int();
+  const char *func_name() const { return "~"; }
+
+  virtual inline void print(String *str, enum_query_type query_type)
+  {
+    Item_func::print(str, query_type);
+  }
+};
+
+
+#endif /* DRIZZLED_FUNCTIONS_BIT_H */

=== added file 'drizzled/functions/bit_count.cc'
--- drizzled/functions/bit_count.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/bit_count.cc	2008-10-14 00:40:14 +0000
@@ -0,0 +1,33 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <mysys/my_bit.h>
+#include <drizzled/functions/bit_count.h>
+
+int64_t Item_func_bit_count::val_int()
+{
+  assert(fixed == 1);
+  uint64_t value= (uint64_t) args[0]->val_int();
+  if ((null_value= args[0]->null_value))
+    return 0; /* purecov: inspected */
+  return (int64_t) my_count_bits(value);
+}
+

=== added file 'drizzled/functions/bit_count.h'
--- drizzled/functions/bit_count.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/bit_count.h	2008-10-14 00:40:14 +0000
@@ -0,0 +1,34 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_BIT_COUNT_H
+#define DRIZZLED_FUNCTIONS_BIT_COUNT_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_bit_count :public Item_int_func
+{
+public:
+  Item_func_bit_count(Item *a) :Item_int_func(a) {}
+  int64_t val_int();
+  const char *func_name() const { return "bit_count"; }
+  void fix_length_and_dec() { max_length=2; }
+};
+
+#endif /* DRIZZLED_FUNCTIONS_BIT_COUNT_H */

=== added file 'drizzled/functions/bit_length.h'
--- drizzled/functions/bit_length.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/bit_length.h	2008-10-14 00:40:14 +0000
@@ -0,0 +1,35 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_BIT_LENGTH_H
+#define DRIZZLED_FUNCTIONS_BIT_LENGTH_H
+
+#include <drizzled/functions/func.h> 
+#include <drizzled/functions/length.h> 
+
+class Item_func_bit_length :public Item_func_length
+{
+public:
+  Item_func_bit_length(Item *a) :Item_func_length(a) {}
+  int64_t val_int()
+    { assert(fixed == 1); return Item_func_length::val_int()*8; }
+  const char *func_name() const { return "bit_length"; }
+};
+
+#endif /* DRIZZLED_FUNCTIONS_BIT_LENGTH_H */

=== added file 'drizzled/functions/char_length.cc'
--- drizzled/functions/char_length.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/char_length.cc	2008-10-17 03:49:29 +0000
@@ -0,0 +1,36 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/char_length.h>
+
+int64_t Item_func_char_length::val_int()
+{
+  assert(fixed == 1);
+  String *res=args[0]->val_str(&value);
+  if (!res)
+  {
+    null_value=1;
+    return 0; /* purecov: inspected */
+  }
+  null_value=0;
+  return (int64_t) res->numchars();
+}
+

=== added file 'drizzled/functions/char_length.h'
--- drizzled/functions/char_length.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/char_length.h	2008-10-17 03:49:29 +0000
@@ -0,0 +1,35 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_CHAR_LENGTH_H
+#define DRIZZLED_FUNCTIONS_CHAR_LENGTH_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_char_length :public Item_int_func
+{
+  String value;
+public:
+  Item_func_char_length(Item *a) :Item_int_func(a) {}
+  int64_t val_int();
+  const char *func_name() const { return "char_length"; }
+  void fix_length_and_dec() { max_length=10; }
+};
+
+#endif /* DRIZZLED_FUNCTIONS_CHAR_LENGTH_H */

=== added file 'drizzled/functions/coercibility.cc'
--- drizzled/functions/coercibility.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/coercibility.cc	2008-10-17 03:49:29 +0000
@@ -0,0 +1,31 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/coercibility.h>
+
+int64_t Item_func_coercibility::val_int()
+{
+  assert(fixed == 1);
+  null_value= 0;
+  return (int64_t) args[0]->collation.derivation;
+}
+
+

=== added file 'drizzled/functions/coercibility.h'
--- drizzled/functions/coercibility.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/coercibility.h	2008-10-17 03:49:29 +0000
@@ -0,0 +1,35 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_COERCIBILITY_H
+#define DRIZZLED_FUNCTIONS_COERCIBILITY_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_coercibility :public Item_int_func
+{
+public:
+  Item_func_coercibility(Item *a) :Item_int_func(a) {}
+  int64_t val_int();
+  const char *func_name() const { return "coercibility"; }
+  void fix_length_and_dec() { max_length=10; maybe_null= 0; }
+  table_map not_null_tables() const { return 0; }
+};
+
+#endif /* DRIZZLED_FUNCTIONS_COERCIBILITY_H */

=== added file 'drizzled/functions/find_in_set.cc'
--- drizzled/functions/find_in_set.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/find_in_set.cc	2008-10-14 00:40:14 +0000
@@ -0,0 +1,104 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/find_in_set.h>
+
+/* Search after a string in a string of strings separated by ',' */
+/* Returns number of found type >= 1 or 0 if not found */
+/* This optimizes searching in enums to bit testing! */
+
+void Item_func_find_in_set::fix_length_and_dec()
+{
+  decimals=0;
+  max_length=3;                                 // 1-999
+  agg_arg_charsets(cmp_collation, args, 2, MY_COLL_CMP_CONV, 1);
+}
+
+static const char separator=',';
+
+int64_t Item_func_find_in_set::val_int()
+{
+  assert(fixed == 1);
+  if (enum_value)
+  {
+    uint64_t tmp=(uint64_t) args[1]->val_int();
+    if (!(null_value=args[1]->null_value || args[0]->null_value))
+    {
+      if (tmp & enum_bit)
+	return enum_value;
+    }
+    return 0L;
+  }
+
+  String *find=args[0]->val_str(&value);
+  String *buffer=args[1]->val_str(&value2);
+  if (!find || !buffer)
+  {
+    null_value=1;
+    return 0; /* purecov: inspected */
+  }
+  null_value=0;
+
+  int diff;
+  if ((diff=buffer->length() - find->length()) >= 0)
+  {
+    my_wc_t wc;
+    const CHARSET_INFO * const cs= cmp_collation.collation;
+    const char *str_begin= buffer->ptr();
+    const char *str_end= buffer->ptr();
+    const char *real_end= str_end+buffer->length();
+    const unsigned char *find_str= (const unsigned char *) find->ptr();
+    uint32_t find_str_len= find->length();
+    int position= 0;
+    while (1)
+    {
+      int symbol_len;
+      if ((symbol_len= cs->cset->mb_wc(cs, &wc, (unsigned char*) str_end, 
+                                       (unsigned char*) real_end)) > 0)
+      {
+        const char *substr_end= str_end + symbol_len;
+        bool is_last_item= (substr_end == real_end);
+        bool is_separator= (wc == (my_wc_t) separator);
+        if (is_separator || is_last_item)
+        {
+          position++;
+          if (is_last_item && !is_separator)
+            str_end= substr_end;
+          if (!my_strnncoll(cs, (const unsigned char *) str_begin,
+                            str_end - str_begin,
+                            find_str, find_str_len))
+            return (int64_t) position;
+          else
+            str_begin= substr_end;
+        }
+        str_end= substr_end;
+      }
+      else if (str_end - str_begin == 0 &&
+               find_str_len == 0 &&
+               wc == (my_wc_t) separator)
+        return (int64_t) ++position;
+      else
+        return 0L;
+    }
+  }
+  return 0;
+}
+

=== added file 'drizzled/functions/find_in_set.h'
--- drizzled/functions/find_in_set.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/find_in_set.h	2008-10-14 00:40:14 +0000
@@ -0,0 +1,38 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_FIND_IN_SET_H
+#define DRIZZLED_FUNCTIONS_FIND_IN_SET_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_find_in_set :public Item_int_func
+{
+  String value,value2;
+  uint32_t enum_value;
+  uint64_t enum_bit;
+  DTCollation cmp_collation;
+public:
+  Item_func_find_in_set(Item *a,Item *b) :Item_int_func(a,b),enum_value(0) {}
+  int64_t val_int();
+  const char *func_name() const { return "find_in_set"; }
+  void fix_length_and_dec();
+};
+
+#endif /* DRIZZLED_FUNCTIONS_FIND_IN_SET_H */

=== modified file 'drizzled/functions/func.cc'
--- drizzled/functions/func.cc	2008-10-22 23:29:43 +0000
+++ drizzled/functions/func.cc	2008-10-25 04:31:54 +0000
@@ -17,6 +17,7 @@
  *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
+using namespace std;
 #include <drizzled/server_includes.h>
 
 #include CSTDINT_H
@@ -508,7 +509,7 @@
 
 double Item_func::fix_result(double value)
 {
-  if (CMATH_NAMESPACE::isfinite(value))
+  if (isfinite(value))
     return value;
   null_value=1;
   return 0.0;

=== added file 'drizzled/functions/get_system_var.cc'
--- drizzled/functions/get_system_var.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/get_system_var.cc	2008-10-25 04:31:54 +0000
@@ -0,0 +1,92 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/error.h>
+#include <drizzled/functions/get_system_var.h>
+
+Item_func_get_system_var::
+Item_func_get_system_var(sys_var *var_arg, enum_var_type var_type_arg,
+                       LEX_STRING *component_arg, const char *name_arg,
+                       size_t name_len_arg)
+  :var(var_arg), var_type(var_type_arg), component(*component_arg)
+{
+  /* set_name() will allocate the name */
+  set_name(name_arg, name_len_arg, system_charset_info);
+}
+
+
+bool
+Item_func_get_system_var::fix_fields(Session *session, Item **ref)
+{
+  Item *item;
+
+  /*
+    Evaluate the system variable and substitute the result (a basic constant)
+    instead of this item. If the variable can not be evaluated,
+    the error is reported in sys_var::item().
+  */
+  if (!(item= var->item(session, var_type, &component)))
+    return(1);                             // Impossible
+  item->set_name(name, 0, system_charset_info); // don't allocate a new name
+  session->change_item_tree(ref, item);
+
+  return(0);
+}
+
+bool Item_func_get_system_var::is_written_to_binlog()
+{
+  return var->is_written_to_binlog(var_type);
+}
+
+Item *get_system_var(Session *session, enum_var_type var_type, LEX_STRING name,
+                     LEX_STRING component)
+{
+  sys_var *var;
+  LEX_STRING *base_name, *component_name;
+
+  if (component.str)
+  {
+    base_name= &component;
+    component_name= &name;
+  }
+  else
+  {
+    base_name= &name;
+    component_name= &component;                 // Empty string
+  }
+
+  if (!(var= find_sys_var(session, base_name->str, base_name->length)))
+    return 0;
+  if (component.str)
+  {
+    if (!var->is_struct())
+    {
+      my_error(ER_VARIABLE_IS_NOT_STRUCT, MYF(0), base_name->str);
+      return 0;
+    }
+  }
+
+  set_if_smaller(component_name->length, MAX_SYS_VAR_LENGTH);
+
+  return new Item_func_get_system_var(var, var_type, component_name,
+                                      NULL, 0);
+}
+

=== added file 'drizzled/functions/get_system_var.h'
--- drizzled/functions/get_system_var.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/get_system_var.h	2008-10-24 03:43:19 +0000
@@ -0,0 +1,59 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_GET_SYSTEM_VAR_H
+#define DRIZZLED_FUNCTIONS_GET_SYSTEM_VAR_H
+
+#include <drizzled/functions/func.h> 
+
+/* A system variable */
+
+class Item_func_get_system_var :public Item_func
+{
+  sys_var *var;
+  enum_var_type var_type;
+  LEX_STRING component;
+public:
+  Item_func_get_system_var(sys_var *var_arg, enum_var_type var_type_arg,
+                           LEX_STRING *component_arg, const char *name_arg,
+                           size_t name_len_arg);
+  bool fix_fields(Session *session, Item **ref);
+  /*
+    Stubs for pure virtual methods. Should never be called: this
+    item is always substituted with a constant in fix_fields().
+  */
+  double val_real()         { assert(0); return 0.0; }
+  int64_t val_int()        { assert(0); return 0; }
+  String* val_str(String*)  { assert(0); return 0; }
+  void fix_length_and_dec() { assert(0); }
+  /* TODO: fix to support views */
+  const char *func_name() const { return "get_system_var"; }
+  /**
+    Indicates whether this system variable is written to the binlog or not.
+
+    Variables are written to the binlog as part of "status_vars" in
+    Query_log_event, as an Intvar_log_event, or a Rand_log_event.
+
+    @return true if the variable is written to the binlog, false otherwise.
+  */
+  bool is_written_to_binlog();
+};
+
+
+#endif /* DRIZZLED_FUNCTIONS_GET_SYSTEM_VAR_H */

=== modified file 'drizzled/functions/int_val.h'
--- drizzled/functions/int_val.h	2008-10-13 03:50:26 +0000
+++ drizzled/functions/int_val.h	2008-10-14 00:40:14 +0000
@@ -21,7 +21,6 @@
 #define DRIZZLED_FUNCTIONS_INT_VAL_H
 
 #include <drizzled/functions/func.h> 
-/* #include <drizzled/functions/num1.h>  */
 
 class Item_func_int_val :public Item_func_num1
 {

=== added file 'drizzled/functions/last_insert.cc'
--- drizzled/functions/last_insert.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/last_insert.cc	2008-10-24 03:43:19 +0000
@@ -0,0 +1,51 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/last_insert.h>
+
+int64_t Item_func_last_insert_id::val_int()
+{
+  Session *session= current_session;
+  assert(fixed == 1);
+  if (arg_count)
+  {
+    int64_t value= args[0]->val_int();
+    null_value= args[0]->null_value;
+    /*
+      LAST_INSERT_ID(X) must affect the client's mysql_insert_id() as
+      documented in the manual. We don't want to touch
+      first_successful_insert_id_in_cur_stmt because it would make
+      LAST_INSERT_ID(X) take precedence over an generated auto_increment
+      value for this row.
+    */
+    session->arg_of_last_insert_id_function= true;
+    session->first_successful_insert_id_in_prev_stmt= value;
+    return value;
+  }
+  return session->read_first_successful_insert_id_in_prev_stmt();
+}
+
+
+bool Item_func_last_insert_id::fix_fields(Session *session, Item **ref)
+{
+  return Item_int_func::fix_fields(session, ref);
+}
+

=== added file 'drizzled/functions/last_insert.h'
--- drizzled/functions/last_insert.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/last_insert.h	2008-10-24 03:43:19 +0000
@@ -0,0 +1,42 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_LAST_INSERT_H
+#define DRIZZLED_FUNCTIONS_LAST_INSERT_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_last_insert_id :public Item_int_func
+{ 
+public:
+  Item_func_last_insert_id() :Item_int_func() {}
+  Item_func_last_insert_id(Item *a) :Item_int_func(a) {}
+  int64_t val_int();
+  const char *func_name() const { return "last_insert_id"; }
+  void fix_length_and_dec()
+  {
+    if (arg_count)
+      max_length= args[0]->max_length;
+  }
+  bool fix_fields(Session *session, Item **ref);
+  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
+  { return true; }
+};
+    
+#endif /* DRIZZLED_FUNCTIONS_LAST_INSERT_H */

=== added file 'drizzled/functions/locate.cc'
--- drizzled/functions/locate.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/locate.cc	2008-10-17 03:49:29 +0000
@@ -0,0 +1,85 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/locate.h>
+
+void Item_func_locate::fix_length_and_dec()
+{
+  max_length= MY_INT32_NUM_DECIMAL_DIGITS;
+  agg_arg_charsets(cmp_collation, args, 2, MY_COLL_CMP_CONV, 1);
+}
+
+int64_t Item_func_locate::val_int()
+{
+  assert(fixed == 1);
+  String *a=args[0]->val_str(&value1);
+  String *b=args[1]->val_str(&value2);
+  if (!a || !b)
+  {
+    null_value=1;
+    return 0; /* purecov: inspected */
+  }
+  null_value=0;
+  /* must be int64_t to avoid truncation */
+  int64_t start=  0;
+  int64_t start0= 0;
+  my_match_t match;
+
+  if (arg_count == 3)
+  {
+    start0= start= args[2]->val_int() - 1;
+
+    if ((start < 0) || (start > a->length()))
+      return 0;
+
+    /* start is now sufficiently valid to pass to charpos function */
+    start= a->charpos((int) start);
+
+    if (start + b->length() > a->length())
+      return 0;
+  }
+  if (!b->length())                             // Found empty string at start
+    return start + 1;
+
+  if (!cmp_collation.collation->coll->instr(cmp_collation.collation,
+                                            a->ptr()+start,
+                                            (uint) (a->length()-start),
+                                            b->ptr(), b->length(),
+                                            &match, 1))
+    return 0;
+  return (int64_t) match.mb_len + start0 + 1;
+}
+
+
+void Item_func_locate::print(String *str, enum_query_type query_type)
+{
+  str->append(STRING_WITH_LEN("locate("));
+  args[1]->print(str, query_type);
+  str->append(',');
+  args[0]->print(str, query_type);
+  if (arg_count == 3)
+  {
+    str->append(',');
+    args[2]->print(str, query_type);
+  }
+  str->append(')');
+}
+

=== added file 'drizzled/functions/locate.h'
--- drizzled/functions/locate.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/locate.h	2008-10-17 03:49:29 +0000
@@ -0,0 +1,38 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_LOCATE_H
+#define DRIZZLED_FUNCTIONS_LOCATE_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_locate :public Item_int_func
+{
+  String value1,value2;
+  DTCollation cmp_collation;
+public:
+  Item_func_locate(Item *a,Item *b) :Item_int_func(a,b) {}
+  Item_func_locate(Item *a,Item *b,Item *c) :Item_int_func(a,b,c) {}
+  const char *func_name() const { return "locate"; }
+  int64_t val_int();
+  void fix_length_and_dec();
+  virtual void print(String *str, enum_query_type query_type);
+};
+
+#endif /* DRIZZLED_FUNCTIONS_LOCATE_H */

=== modified file 'drizzled/functions/neg.h'
--- drizzled/functions/neg.h	2008-10-13 10:14:09 +0000
+++ drizzled/functions/neg.h	2008-10-14 00:40:14 +0000
@@ -21,7 +21,7 @@
 #define DRIZZLED_FUNCTIONS_NEG_H
 
 #include <drizzled/functions/func.h> 
-#include <drizzled/functions/num1.h> 
+#include <drizzled/functions/num1.h>
 
 class Item_func_neg :public Item_func_num1
 {

=== added file 'drizzled/functions/ord.cc'
--- drizzled/functions/ord.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/ord.cc	2008-10-14 00:40:14 +0000
@@ -0,0 +1,49 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/ord.h>
+
+int64_t Item_func_ord::val_int()
+{
+  assert(fixed == 1);
+  String *res=args[0]->val_str(&value);
+  if (!res)
+  {
+    null_value=1;
+    return 0;
+  }
+  null_value=0;
+  if (!res->length()) return 0;
+#ifdef USE_MB
+  if (use_mb(res->charset()))
+  {
+    register const char *str=res->ptr();
+    register uint32_t n=0, l=my_ismbchar(res->charset(),str,str+res->length());
+    if (!l)
+      return (int64_t)((unsigned char) *str);
+    while (l--)
+      n=(n<<8)|(uint32_t)((unsigned char) *str++);
+    return (int64_t) n;
+  }
+#endif
+  return (int64_t) ((unsigned char) (*res)[0]);
+}
+

=== added file 'drizzled/functions/ord.h'
--- drizzled/functions/ord.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/ord.h	2008-10-14 00:40:14 +0000
@@ -0,0 +1,34 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_ORD_H
+#define DRIZZLED_FUNCTIONS_ORD_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_ord :public Item_int_func
+{
+  String value;
+public:
+  Item_func_ord(Item *a) :Item_int_func(a) {}
+  int64_t val_int();
+  const char *func_name() const { return "ord"; }
+};
+
+#endif /* DRIZZLED_FUNCTIONS_ORD_H */

=== added file 'drizzled/functions/rollup_const.h'
--- drizzled/functions/rollup_const.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/rollup_const.h	2008-10-24 03:43:19 +0000
@@ -0,0 +1,56 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_ROLLUP_CONST_H
+#define DRIZZLED_FUNCTIONS_ROLLUP_CONST_H
+
+#include <drizzled/functions/func.h> 
+
+/*
+  Objects of this class are used for ROLLUP queries to wrap up
+  each constant item referred to in GROUP BY list.
+*/
+
+class Item_func_rollup_const :public Item_func
+{
+public:
+  Item_func_rollup_const(Item *a) :Item_func(a)
+  {
+    name= a->name;
+    name_length= a->name_length;
+  }
+  double val_real() { return args[0]->val_real(); }
+  int64_t val_int() { return args[0]->val_int(); }
+  String *val_str(String *str) { return args[0]->val_str(str); }
+  my_decimal *val_decimal(my_decimal *dec) { return args[0]->val_decimal(dec); }
+  const char *func_name() const { return "rollup_const"; }
+  bool const_item() const { return 0; }
+  Item_result result_type() const { return args[0]->result_type(); }
+  void fix_length_and_dec()
+  {
+    collation= args[0]->collation;
+    max_length= args[0]->max_length;
+    decimals=args[0]->decimals;
+    /* The item could be a NULL constant. */
+    null_value= args[0]->is_null();
+  }
+};
+
+
+#endif /* DRIZZLED_FUNCTIONS_ROLLUP_CONST_H */

=== modified file 'drizzled/functions/round.cc'
--- drizzled/functions/round.cc	2008-10-13 21:02:40 +0000
+++ drizzled/functions/round.cc	2008-10-24 21:49:14 +0000
@@ -17,6 +17,7 @@
  *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  */
 
+using namespace std;
 #include <drizzled/server_includes.h>
 #include CSTDINT_H
 #include <drizzled/functions/round.h>
@@ -109,9 +110,9 @@
   tmp=(abs_dec < array_elements(log_10) ?
        log_10[abs_dec] : pow(10.0,(double) abs_dec));
 
-  if (dec_negative && std::isinf(tmp))
+  if (dec_negative && isinf(tmp))
     tmp2= 0;
-  else if (!dec_negative && std::isinf(value * tmp))
+  else if (!dec_negative && isinf(value * tmp))
     tmp2= value;
   else if (truncate)
   {

=== added file 'drizzled/functions/units.cc'
--- drizzled/functions/units.cc	1970-01-01 00:00:00 +0000
+++ drizzled/functions/units.cc	2008-10-17 03:49:29 +0000
@@ -0,0 +1,33 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include <drizzled/server_includes.h>
+#include CSTDINT_H
+#include <drizzled/functions/units.h>
+
+double Item_func_units::val_real()
+{
+  assert(fixed == 1);
+  double value= args[0]->val_real();
+  if ((null_value=args[0]->null_value))
+    return 0;
+  return value*mul+add;
+}
+
+

=== added file 'drizzled/functions/units.h'
--- drizzled/functions/units.h	1970-01-01 00:00:00 +0000
+++ drizzled/functions/units.h	2008-10-17 03:49:29 +0000
@@ -0,0 +1,38 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLED_FUNCTIONS_UNITS_H
+#define DRIZZLED_FUNCTIONS_UNITS_H
+
+#include <drizzled/functions/func.h> 
+
+class Item_func_units :public Item_real_func
+{
+  char *name;
+  double mul,add;
+public:
+  Item_func_units(char *name_arg,Item *a,double mul_arg,double add_arg)
+    :Item_real_func(a),name(name_arg),mul(mul_arg),add(add_arg) {}
+  double val_real();
+  const char *func_name() const { return name; }
+  void fix_length_and_dec()
+  { decimals= NOT_FIXED_DEC; max_length= float_length(decimals); }
+};
+
+#endif /* DRIZZLED_FUNCTIONS_UNITS_H */

=== modified file 'drizzled/item_create.cc'
--- drizzled/item_create.cc	2008-10-23 03:41:40 +0000
+++ drizzled/item_create.cc	2008-10-25 04:31:54 +0000
@@ -21,6 +21,8 @@
 */
 
 #include <drizzled/server_includes.h>
+#include <drizzled/functions/coercibility.h>
+#include <drizzled/functions/locate.h>
 #include <drizzled/error.h>
 
 /*

=== modified file 'drizzled/item_func.cc'
--- drizzled/item_func.cc	2008-10-23 02:48:56 +0000
+++ drizzled/item_func.cc	2008-10-25 04:31:54 +0000
@@ -182,17 +182,6 @@
   return (shift < sizeof(int64_t)*8 ? (int64_t) res : 0);
 }
 
-
-int64_t Item_func_bit_neg::val_int()
-{
-  assert(fixed == 1);
-  uint64_t res= (uint64_t) args[0]->val_int();
-  if ((null_value=args[0]->null_value))
-    return 0;
-  return ~res;
-}
-
-
 // Conversion functions
 
 void Item_func_integer::fix_length_and_dec()
@@ -203,103 +192,6 @@
   decimals=0;
 }
 
-double Item_func_units::val_real()
-{
-  assert(fixed == 1);
-  double value= args[0]->val_real();
-  if ((null_value=args[0]->null_value))
-    return 0;
-  return value*mul+add;
-}
-
-
-int64_t Item_func_char_length::val_int()
-{
-  assert(fixed == 1);
-  String *res=args[0]->val_str(&value);
-  if (!res)
-  {
-    null_value=1;
-    return 0; /* purecov: inspected */
-  }
-  null_value=0;
-  return (int64_t) res->numchars();
-}
-
-
-int64_t Item_func_coercibility::val_int()
-{
-  assert(fixed == 1);
-  null_value= 0;
-  return (int64_t) args[0]->collation.derivation;
-}
-
-
-void Item_func_locate::fix_length_and_dec()
-{
-  max_length= MY_INT32_NUM_DECIMAL_DIGITS;
-  agg_arg_charsets(cmp_collation, args, 2, MY_COLL_CMP_CONV, 1);
-}
-
-
-int64_t Item_func_locate::val_int()
-{
-  assert(fixed == 1);
-  String *a=args[0]->val_str(&value1);
-  String *b=args[1]->val_str(&value2);
-  if (!a || !b)
-  {
-    null_value=1;
-    return 0; /* purecov: inspected */
-  }
-  null_value=0;
-  /* must be int64_t to avoid truncation */
-  int64_t start=  0; 
-  int64_t start0= 0;
-  my_match_t match;
-
-  if (arg_count == 3)
-  {
-    start0= start= args[2]->val_int() - 1;
-
-    if ((start < 0) || (start > a->length()))
-      return 0;
-
-    /* start is now sufficiently valid to pass to charpos function */
-    start= a->charpos((int) start);
-
-    if (start + b->length() > a->length())
-      return 0;
-  }
-
-  if (!b->length())				// Found empty string at start
-    return start + 1;
-  
-  if (!cmp_collation.collation->coll->instr(cmp_collation.collation,
-                                            a->ptr()+start,
-                                            (uint) (a->length()-start),
-                                            b->ptr(), b->length(),
-                                            &match, 1))
-    return 0;
-  return (int64_t) match.mb_len + start0 + 1;
-}
-
-
-void Item_func_locate::print(String *str, enum_query_type query_type)
-{
-  str->append(STRING_WITH_LEN("locate("));
-  args[1]->print(str, query_type);
-  str->append(',');
-  args[0]->print(str, query_type);
-  if (arg_count == 3)
-  {
-    str->append(',');
-    args[2]->print(str, query_type);
-  }
-  str->append(')');
-}
-
-
 int64_t Item_func_field::val_int()
 {
   assert(fixed == 1);
@@ -366,19 +258,6 @@
 }
 
 
-int64_t Item_func_ascii::val_int()
-{
-  assert(fixed == 1);
-  String *res=args[0]->val_str(&value);
-  if (!res)
-  {
-    null_value=1;
-    return 0;
-  }
-  null_value=0;
-  return (int64_t) (res->length() ? (unsigned char) (*res)[0] : (unsigned char) 0);
-}
-
 int64_t Item_func_ord::val_int()
 {
   assert(fixed == 1);
@@ -405,96 +284,6 @@
   return (int64_t) ((unsigned char) (*res)[0]);
 }
 
-	/* Search after a string in a string of strings separated by ',' */
-	/* Returns number of found type >= 1 or 0 if not found */
-	/* This optimizes searching in enums to bit testing! */
-
-void Item_func_find_in_set::fix_length_and_dec()
-{
-  decimals=0;
-  max_length=3;					// 1-999
-  agg_arg_charsets(cmp_collation, args, 2, MY_COLL_CMP_CONV, 1);
-}
-
-static const char separator=',';
-
-int64_t Item_func_find_in_set::val_int()
-{
-  assert(fixed == 1);
-  if (enum_value)
-  {
-    uint64_t tmp=(uint64_t) args[1]->val_int();
-    if (!(null_value=args[1]->null_value || args[0]->null_value))
-    {
-      if (tmp & enum_bit)
-	return enum_value;
-    }
-    return 0L;
-  }
-
-  String *find=args[0]->val_str(&value);
-  String *buffer=args[1]->val_str(&value2);
-  if (!find || !buffer)
-  {
-    null_value=1;
-    return 0; /* purecov: inspected */
-  }
-  null_value=0;
-
-  int diff;
-  if ((diff=buffer->length() - find->length()) >= 0)
-  {
-    my_wc_t wc;
-    const CHARSET_INFO * const cs= cmp_collation.collation;
-    const char *str_begin= buffer->ptr();
-    const char *str_end= buffer->ptr();
-    const char *real_end= str_end+buffer->length();
-    const unsigned char *find_str= (const unsigned char *) find->ptr();
-    uint32_t find_str_len= find->length();
-    int position= 0;
-    while (1)
-    {
-      int symbol_len;
-      if ((symbol_len= cs->cset->mb_wc(cs, &wc, (unsigned char*) str_end, 
-                                       (unsigned char*) real_end)) > 0)
-      {
-        const char *substr_end= str_end + symbol_len;
-        bool is_last_item= (substr_end == real_end);
-        bool is_separator= (wc == (my_wc_t) separator);
-        if (is_separator || is_last_item)
-        {
-          position++;
-          if (is_last_item && !is_separator)
-            str_end= substr_end;
-          if (!my_strnncoll(cs, (const unsigned char *) str_begin,
-                            str_end - str_begin,
-                            find_str, find_str_len))
-            return (int64_t) position;
-          else
-            str_begin= substr_end;
-        }
-        str_end= substr_end;
-      }
-      else if (str_end - str_begin == 0 &&
-               find_str_len == 0 &&
-               wc == (my_wc_t) separator)
-        return (int64_t) ++position;
-      else
-        return 0L;
-    }
-  }
-  return 0;
-}
-
-int64_t Item_func_bit_count::val_int()
-{
-  assert(fixed == 1);
-  uint64_t value= (uint64_t) args[0]->val_int();
-  if ((null_value= args[0]->null_value))
-    return 0; /* purecov: inspected */
-  return (int64_t) my_count_bits(value);
-}
-
 /*
 ** User level locks
 */
@@ -616,101 +405,6 @@
 
 #endif
 
-
-int64_t Item_func_last_insert_id::val_int()
-{
-  Session *session= current_session;
-  assert(fixed == 1);
-  if (arg_count)
-  {
-    int64_t value= args[0]->val_int();
-    null_value= args[0]->null_value;
-    /*
-      LAST_INSERT_ID(X) must affect the client's mysql_insert_id() as
-      documented in the manual. We don't want to touch
-      first_successful_insert_id_in_cur_stmt because it would make
-      LAST_INSERT_ID(X) take precedence over an generated auto_increment
-      value for this row.
-    */
-    session->arg_of_last_insert_id_function= true;
-    session->first_successful_insert_id_in_prev_stmt= value;
-    return value;
-  }
-  return session->read_first_successful_insert_id_in_prev_stmt();
-}
-
-
-bool Item_func_last_insert_id::fix_fields(Session *session, Item **ref)
-{
-  return Item_int_func::fix_fields(session, ref);
-}
-
-
-/* This function is just used to test speed of different functions */
-
-int64_t Item_func_benchmark::val_int()
-{
-  assert(fixed == 1);
-  char buff[MAX_FIELD_WIDTH];
-  String tmp(buff,sizeof(buff), &my_charset_bin);
-  my_decimal tmp_decimal;
-  Session *session=current_session;
-  uint64_t loop_count;
-
-  loop_count= (uint64_t) args[0]->val_int();
-
-  if (args[0]->null_value ||
-      (!args[0]->unsigned_flag && (((int64_t) loop_count) < 0)))
-  {
-    if (!args[0]->null_value)
-    {
-      char buff[22];
-      llstr(((int64_t) loop_count), buff);
-      push_warning_printf(current_session, DRIZZLE_ERROR::WARN_LEVEL_ERROR,
-                          ER_WRONG_VALUE_FOR_TYPE, ER(ER_WRONG_VALUE_FOR_TYPE),
-                          "count", buff, "benchmark");
-    }
-
-    null_value= 1;
-    return 0;
-  }
-
-  null_value=0;
-  for (uint64_t loop=0 ; loop < loop_count && !session->killed; loop++)
-  {
-    switch (args[1]->result_type()) {
-    case REAL_RESULT:
-      (void) args[1]->val_real();
-      break;
-    case INT_RESULT:
-      (void) args[1]->val_int();
-      break;
-    case STRING_RESULT:
-      (void) args[1]->val_str(&tmp);
-      break;
-    case DECIMAL_RESULT:
-      (void) args[1]->val_decimal(&tmp_decimal);
-      break;
-    case ROW_RESULT:
-    default:
-      // This case should never be chosen
-      assert(0);
-      return 0;
-    }
-  }
-  return 0;
-}
-
-
-void Item_func_benchmark::print(String *str, enum_query_type query_type)
-{
-  str->append(STRING_WITH_LEN("benchmark("));
-  args[0]->print(str, query_type);
-  str->append(',');
-  args[1]->print(str, query_type);
-  str->append(')');
-}
-
 #define extra_size sizeof(double)
 
 static user_var_entry *get_variable(HASH *hash, LEX_STRING &name,
@@ -1735,53 +1429,6 @@
   str->append(name.str,name.length);
 }
 
-
-Item_func_get_system_var::
-Item_func_get_system_var(sys_var *var_arg, enum_var_type var_type_arg,
-                       LEX_STRING *component_arg, const char *name_arg,
-                       size_t name_len_arg)
-  :var(var_arg), var_type(var_type_arg), component(*component_arg)
-{
-  /* set_name() will allocate the name */
-  set_name(name_arg, name_len_arg, system_charset_info);
-}
-
-
-bool
-Item_func_get_system_var::fix_fields(Session *session, Item **ref)
-{
-  Item *item;
-
-  /*
-    Evaluate the system variable and substitute the result (a basic constant)
-    instead of this item. If the variable can not be evaluated,
-    the error is reported in sys_var::item().
-  */
-  if (!(item= var->item(session, var_type, &component)))
-    return(1);                             // Impossible
-  item->set_name(name, 0, system_charset_info); // don't allocate a new name
-  session->change_item_tree(ref, item);
-
-  return(0);
-}
-
-
-bool Item_func_get_system_var::is_written_to_binlog()
-{
-  return var->is_written_to_binlog(var_type);
-}
-
-int64_t Item_func_bit_xor::val_int()
-{
-  assert(fixed == 1);
-  uint64_t arg1= (uint64_t) args[0]->val_int();
-  uint64_t arg2= (uint64_t) args[1]->val_int();
-  if ((null_value= (args[0]->null_value || args[1]->null_value)))
-    return 0;
-  return (int64_t) (arg1 ^ arg2);
-}
-
-
 /***************************************************************************
   System variables
 ****************************************************************************/
@@ -1803,41 +1450,6 @@
 */
 
 
-Item *get_system_var(Session *session, enum_var_type var_type, LEX_STRING name,
-		     LEX_STRING component)
-{
-  sys_var *var;
-  LEX_STRING *base_name, *component_name;
-
-  if (component.str)
-  {
-    base_name= &component;
-    component_name= &name;
-  }
-  else
-  {
-    base_name= &name;
-    component_name= &component;			// Empty string
-  }
-
-  if (!(var= find_sys_var(session, base_name->str, base_name->length)))
-    return 0;
-  if (component.str)
-  {
-    if (!var->is_struct())
-    {
-      my_error(ER_VARIABLE_IS_NOT_STRUCT, MYF(0), base_name->str);
-      return 0;
-    }
-  }
-
-  set_if_smaller(component_name->length, MAX_SYS_VAR_LENGTH);
-
-  return new Item_func_get_system_var(var, var_type, component_name,
-                                      NULL, 0);
-}
-
-
 /**
   Check a user level lock.
 

=== modified file 'drizzled/item_func.h'
--- drizzled/item_func.h	2008-10-20 04:28:21 +0000
+++ drizzled/item_func.h	2008-10-24 03:43:19 +0000
@@ -35,7 +35,12 @@
 #include <drizzled/functions/connection_id.h>
 #include <drizzled/functions/decimal_typecast.h>
 #include <drizzled/functions/divide.h>
+#include <drizzled/functions/get_system_var.h>
 #include <drizzled/functions/int.h>
+#include <drizzled/functions/bit.h>
+#include <drizzled/functions/bit_count.h>
+#include <drizzled/functions/bit_length.h>
+#include <drizzled/functions/find_in_set.h>
 #include <drizzled/functions/int_divide.h>
 #include <drizzled/functions/length.h>
 #include <drizzled/functions/min_max.h>
@@ -49,17 +54,24 @@
 #include <drizzled/functions/abs.h>
 #include <drizzled/functions/plus.h>
 #include <drizzled/functions/real.h>
+#include <drizzled/functions/rollup_const.h>
 #include <drizzled/functions/dec.h>
 #include <drizzled/functions/int_val.h>
 #include <drizzled/functions/acos.h>
+#include <drizzled/functions/ascii.h>
 #include <drizzled/functions/asin.h>
 #include <drizzled/functions/atan.h>
+#include <drizzled/functions/benchmark.h>
+#include <drizzled/functions/char_length.h>
 #include <drizzled/functions/ceiling.h>
 #include <drizzled/functions/cos.h>
 #include <drizzled/functions/exp.h>
 #include <drizzled/functions/floor.h>
+#include <drizzled/functions/last_insert.h>
 #include <drizzled/functions/ln.h>
 #include <drizzled/functions/log.h>
+#include <drizzled/functions/units.h>
+#include <drizzled/functions/ord.h>
 #include <drizzled/functions/pow.h>
 #include <drizzled/functions/rand.h>
 #include <drizzled/functions/round.h>
@@ -77,93 +89,6 @@
   void fix_length_and_dec();
 };
 
-class Item_func_units :public Item_real_func
-{
-  char *name;
-  double mul,add;
-public:
-  Item_func_units(char *name_arg,Item *a,double mul_arg,double add_arg)
-    :Item_real_func(a),name(name_arg),mul(mul_arg),add(add_arg) {}
-  double val_real();
-  const char *func_name() const { return name; }
-  void fix_length_and_dec()
-  { decimals= NOT_FIXED_DEC; max_length= float_length(decimals); }
-};
-
-
-/* 
-  Objects of this class are used for ROLLUP queries to wrap up 
-  each constant item referred to in GROUP BY list. 
-*/
-
-class Item_func_rollup_const :public Item_func
-{
-public:
-  Item_func_rollup_const(Item *a) :Item_func(a)
-  {
-    name= a->name;
-    name_length= a->name_length;
-  }
-  double val_real() { return args[0]->val_real(); }
-  int64_t val_int() { return args[0]->val_int(); }
-  String *val_str(String *str) { return args[0]->val_str(str); }
-  my_decimal *val_decimal(my_decimal *dec) { return args[0]->val_decimal(dec); }
-  const char *func_name() const { return "rollup_const"; }
-  bool const_item() const { return 0; }
-  Item_result result_type() const { return args[0]->result_type(); }
-  void fix_length_and_dec()
-  {
-    collation= args[0]->collation;
-    max_length= args[0]->max_length;
-    decimals=args[0]->decimals; 
-    /* The item could be a NULL constant. */
-    null_value= args[0]->is_null();
-  }
-};
-
-class Item_func_bit_length :public Item_func_length
-{
-public:
-  Item_func_bit_length(Item *a) :Item_func_length(a) {}
-  int64_t val_int()
-    { assert(fixed == 1); return Item_func_length::val_int()*8; }
-  const char *func_name() const { return "bit_length"; }
-};
-
-class Item_func_char_length :public Item_int_func
-{
-  String value;
-public:
-  Item_func_char_length(Item *a) :Item_int_func(a) {}
-  int64_t val_int();
-  const char *func_name() const { return "char_length"; }
-  void fix_length_and_dec() { max_length=10; }
-};
-
-class Item_func_coercibility :public Item_int_func
-{
-public:
-  Item_func_coercibility(Item *a) :Item_int_func(a) {}
-  int64_t val_int();
-  const char *func_name() const { return "coercibility"; }
-  void fix_length_and_dec() { max_length=10; maybe_null= 0; }
-  table_map not_null_tables() const { return 0; }
-};
-
-class Item_func_locate :public Item_int_func
-{
-  String value1,value2;
-  DTCollation cmp_collation;
-public:
-  Item_func_locate(Item *a,Item *b) :Item_int_func(a,b) {}
-  Item_func_locate(Item *a,Item *b,Item *c) :Item_int_func(a,b,c) {}
-  const char *func_name() const { return "locate"; }
-  int64_t val_int();
-  void fix_length_and_dec();
-  virtual void print(String *str, enum_query_type query_type);
-};
-
-
 class Item_func_field :public Item_int_func
 {
   String value,tmp;
@@ -176,141 +101,6 @@
   void fix_length_and_dec();
 };
 
-
-class Item_func_ascii :public Item_int_func
-{
-  String value;
-public:
-  Item_func_ascii(Item *a) :Item_int_func(a) {}
-  int64_t val_int();
-  const char *func_name() const { return "ascii"; }
-  void fix_length_and_dec() { max_length=3; }
-};
-
-class Item_func_ord :public Item_int_func
-{
-  String value;
-public:
-  Item_func_ord(Item *a) :Item_int_func(a) {}
-  int64_t val_int();
-  const char *func_name() const { return "ord"; }
-};
-
-class Item_func_find_in_set :public Item_int_func
-{
-  String value,value2;
-  uint32_t enum_value;
-  uint64_t enum_bit;
-  DTCollation cmp_collation;
-public:
-  Item_func_find_in_set(Item *a,Item *b) :Item_int_func(a,b),enum_value(0) {}
-  int64_t val_int();
-  const char *func_name() const { return "find_in_set"; }
-  void fix_length_and_dec();
-};
-
-/* Base class for all bit functions: '~', '|', '^', '&', '>>', '<<' */
-
-class Item_func_bit: public Item_int_func
-{
-public:
-  Item_func_bit(Item *a, Item *b) :Item_int_func(a, b) {}
-  Item_func_bit(Item *a) :Item_int_func(a) {}
-  void fix_length_and_dec() { unsigned_flag= 1; }
-
-  virtual inline void print(String *str, enum_query_type query_type)
-  {
-    print_op(str, query_type);
-  }
-};
-
-class Item_func_bit_or :public Item_func_bit
-{
-public:
-  Item_func_bit_or(Item *a, Item *b) :Item_func_bit(a, b) {}
-  int64_t val_int();
-  const char *func_name() const { return "|"; }
-};
-
-class Item_func_bit_and :public Item_func_bit
-{
-public:
-  Item_func_bit_and(Item *a, Item *b) :Item_func_bit(a, b) {}
-  int64_t val_int();
-  const char *func_name() const { return "&"; }
-};
-
-class Item_func_bit_count :public Item_int_func
-{
-public:
-  Item_func_bit_count(Item *a) :Item_int_func(a) {}
-  int64_t val_int();
-  const char *func_name() const { return "bit_count"; }
-  void fix_length_and_dec() { max_length=2; }
-};
-
-class Item_func_shift_left :public Item_func_bit
-{
-public:
-  Item_func_shift_left(Item *a, Item *b) :Item_func_bit(a, b) {}
-  int64_t val_int();
-  const char *func_name() const { return "<<"; }
-};
-
-class Item_func_shift_right :public Item_func_bit
-{
-public:
-  Item_func_shift_right(Item *a, Item *b) :Item_func_bit(a, b) {}
-  int64_t val_int();
-  const char *func_name() const { return ">>"; }
-};
-
-class Item_func_bit_neg :public Item_func_bit
-{
-public:
-  Item_func_bit_neg(Item *a) :Item_func_bit(a) {}
-  int64_t val_int();
-  const char *func_name() const { return "~"; }
-
-  virtual inline void print(String *str, enum_query_type query_type)
-  {
-    Item_func::print(str, query_type);
-  }
-};
-
-
-class Item_func_last_insert_id :public Item_int_func
-{
-public:
-  Item_func_last_insert_id() :Item_int_func() {}
-  Item_func_last_insert_id(Item *a) :Item_int_func(a) {}
-  int64_t val_int();
-  const char *func_name() const { return "last_insert_id"; }
-  void fix_length_and_dec()
-  {
-    if (arg_count)
-      max_length= args[0]->max_length;
-  }
-  bool fix_fields(Session *session, Item **ref);
-  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
-  { return true; }
-};
-
-
-class Item_func_benchmark :public Item_int_func
-{
-public:
-  Item_func_benchmark(Item *count_expr, Item *expr)
-    :Item_int_func(count_expr, expr)
-  {}
-  int64_t val_int();
-  const char *func_name() const { return "benchmark"; }
-  void fix_length_and_dec() { max_length=1; maybe_null=0; }
-  virtual void print(String *str, enum_query_type query_type);
-  bool check_vcol_func_processor(unsigned char *int_arg __attribute__((unused)))
-  { return true; }
-};
-
 /* replication functions */
 
 class Item_master_pos_wait :public Item_int_func
@@ -444,47 +234,6 @@
 };
 
 
-/* A system variable */
-
-class Item_func_get_system_var :public Item_func
-{
-  sys_var *var;
-  enum_var_type var_type;
-  LEX_STRING component;
-public:
-  Item_func_get_system_var(sys_var *var_arg, enum_var_type var_type_arg,
-                           LEX_STRING *component_arg, const char *name_arg,
-                           size_t name_len_arg);
-  bool fix_fields(Session *session, Item **ref);
-  /*
-    Stubs for pure virtual methods. Should never be called: this
-    item is always substituted with a constant in fix_fields().
-  */
-  double val_real()         { assert(0); return 0.0; }
-  int64_t val_int()        { assert(0); return 0; }
-  String* val_str(String*)  { assert(0); return 0; }
-  void fix_length_and_dec() { assert(0); }
-  /* TODO: fix to support views */
-  const char *func_name() const { return "get_system_var"; }
-  /**
-    Indicates whether this system variable is written to the binlog or not.
-
-    Variables are written to the binlog as part of "status_vars" in
-    Query_log_event, as an Intvar_log_event, or a Rand_log_event.
-
-    @return true if the variable is written to the binlog, false otherwise.
-  */
-  bool is_written_to_binlog();
-};
-
-class Item_func_bit_xor : public Item_func_bit
-{
-public:
-  Item_func_bit_xor(Item *a, Item *b) :Item_func_bit(a, b) {}
-  int64_t val_int();
-  const char *func_name() const { return "^"; }
-};
-
 class Item_func_is_free_lock :public Item_int_func
 {
   String value;

=== modified file 'drizzled/item_strfunc.cc'
--- drizzled/item_strfunc.cc	2008-10-23 02:48:56 +0000
+++ drizzled/item_strfunc.cc	2008-10-25 04:31:54 +0000
@@ -25,6 +25,7 @@
     (This shouldn't be needed)
 */
 
+using namespace std;
 #include <drizzled/server_includes.h>
 #include <mysys/sha1.h>
 #include <zlib.h>
@@ -1407,7 +1408,7 @@
     nr= my_double_round(nr, (int64_t) dec, false, false);
     /* Here default_charset() is right as this is not an automatic conversion */
     str->set_real(nr, dec, default_charset());
-    if (std::isnan(nr))
+    if (isnan(nr))
       return str;
     str_length=str->length();
     if (nr < 0)

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2008-10-24 03:26:55 +0000
+++ drizzled/sql_yacc.yy	2008-10-25 04:31:54 +0000
@@ -39,6 +39,7 @@
 #define Select Lex->current_select
 #include <drizzled/server_includes.h>
 #include "lex_symbol.h"
+#include <drizzled/functions/locate.h>
 #include <drizzled/error.h>
 #include <drizzled/nested_join.h>
 

=== modified file 'drizzled/stacktrace.h'
--- drizzled/stacktrace.h	2008-10-06 05:57:49 +0000
+++ drizzled/stacktrace.h	2008-10-25 04:31:54 +0000
@@ -23,11 +23,11 @@
 extern "C" {
 #endif
 
-#if HAVE_BACKTRACE && HAVE_BACKTRACE_SYMBOLS && HAVE_CXXABI_H && HAVE_ABI_CXA_DEMANGLE
+#if defined(HAVE_BACKTRACE) && HAVE_BACKTRACE_SYMBOLS && HAVE_CXXABI_H && HAVE_ABI_CXA_DEMANGLE
 #define BACKTRACE_DEMANGLE 1
 #endif
 
-#if BACKTRACE_DEMANGLE
+#if defined(BACKTRACE_DEMANGLE)
   char *my_demangle(const char *mangled_name, int *status);
 #endif
 

=== modified file 'libdrizzle/drizzle.c'
--- libdrizzle/drizzle.c	2008-10-22 23:29:43 +0000
+++ libdrizzle/drizzle.c	2008-10-25 04:31:54 +0000
@@ -18,6 +18,7 @@
  */
 
 #include <config.h>
+#include <signal.h>
 
 #include <drizzled/common.h>
 #include <libdrizzle/libdrizzle.h>

=== modified file 'storage/myisam/mi_dynrec.c'
--- storage/myisam/mi_dynrec.c	2008-10-09 22:38:27 +0000
+++ storage/myisam/mi_dynrec.c	2008-10-24 21:49:14 +0000
@@ -94,7 +94,8 @@
     info->s->file_map= NULL;
     return(1);
   }
-#if defined(HAVE_MADVISE)
+/* per krow we should look at removing the following code */
+#if defined(HAVE_MADVISE) && !defined(TARGET_OS_SOLARIS)
   madvise((char*) info->s->file_map, size, MADV_RANDOM);
 #endif
   info->s->mmaped_length= size;

=== modified file 'storage/myisam/mi_extra.c'
--- storage/myisam/mi_extra.c	2008-10-09 22:38:27 +0000
+++ storage/myisam/mi_extra.c	2008-10-25 04:31:54 +0000
@@ -14,10 +14,9 @@
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
 
 #include "myisamdef.h"
-#ifdef HAVE_SYS_MMAN_H
+#include <drizzled/util/test.h>
+#include <sys/types.h>
 #include <sys/mman.h>
-#endif
-#include <drizzled/util/test.h>
 
 static void mi_extra_keyflag(MI_INFO *info, enum ha_extra_function function);
 
@@ -139,7 +138,7 @@
       error=end_io_cache(&info->rec_cache);
       /* Sergei will insert full text index caching here */
     }
-#if defined(HAVE_MMAP) && defined(HAVE_MADVISE)
+#if defined(HAVE_MMAP) && defined(HAVE_MADVISE) && !defined(TARGET_OS_SOLARIS)
     if (info->opt_flag & MEMMAP_USED)
       madvise((char*) share->file_map, share->state.state.data_file_length,
               MADV_RANDOM);
@@ -413,7 +412,7 @@
   }
   if (share->base.blobs)
     mi_alloc_rec_buff(info, -1, &info->rec_buff);
-#if defined(HAVE_MMAP) && defined(HAVE_MADVISE)
+#if defined(HAVE_MMAP) && defined(HAVE_MADVISE) && !defined(TARGET_OS_SOLARIS)
   if (info->opt_flag & MEMMAP_USED)
     madvise((char*) share->file_map, share->state.state.data_file_length,
             MADV_RANDOM);

=== modified file 'storage/myisam/myisamchk.c'
--- storage/myisam/myisamchk.c	2008-10-10 00:07:05 +0000
+++ storage/myisam/myisamchk.c	2008-10-24 21:49:14 +0000
@@ -667,6 +667,8 @@
       method_conv= MI_STATS_METHOD_IGNORE_NULLS;
       break;
     default: assert(0);                         /* Impossible */
+      fprintf(stderr, "Invalid value of stats_method: %s.\n", argument);
+      exit(1);
     }
     check_param.stats_method= method_conv;
     break;

